#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
using namespace std ;
using state = vector<int> ;
vector<int> a ;
vector<int> nv ;
set<state> seen ;
int r = 0 ;
void split(vector<int> &p, int at, int val, int x, vector<state> &ncur,
           int lasti) {
   if (at == (int)p.size()) {
      if (val <= x) {
         vector<int> nnv = nv ;
         sort(nnv.begin(), nnv.end()) ;
         if (seen.find(nnv) == seen.end()) {
            ncur.push_back(nnv) ;
            seen.insert(nnv) ;
         }
      }
      return ;
   }
   for (int i=0; i<=val && i<=p[at]; i++) {
      // order splits on identical sizes
      //if (at > 0 && p[at]==p[at-1] && i < lasti)
        // continue ;
      if (i > 1)
         nv.push_back(i) ;
      if (p[at]-i > 1)
         nv.push_back(p[at]-i) ;
      split(p, at+1, val-i, x, ncur, i) ;
      if (i > 1)
         nv.pop_back() ;
      if (p[at]-i > 1)
         nv.pop_back() ;
   }
}
int main(int argc, char *argv[]) {
   int n, m ;
   cin >> n >> m ;
   a.resize(m) ;
   for (auto &v : a)
      cin >> v ;
   vector<state> cur({{n}}) ;
   seen.insert({n}) ;
   for (auto v : a) {
      vector<state> ncur ;
      for (auto s : cur) {
         int x = n ;
         for (auto v : s)
            x -= v ;
         r = max(r, x) ;
         split(s, 0, v, x, ncur, -1) ;
      }
      swap(cur, ncur) ;
   }
   for (auto s : cur) {
      int x = n ;
      for (auto v : s)
         x -= v ;
      r = max(r, x) ;
   }
   cout << r << endl ;
}
