#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

void doit(int i, const vector<int>& p, vector<int>& p2, int at, int bt, int lasta, vector<vector<int>>& out) {
  if (i == p.size()) {
    out.push_back(p2);
  } else {
    for (int a = max(0, p[i]-bt); a <= p[i] && a <= at; a++) {
      if (i > 0 && p[i] == p[i-1] && a < lasta) continue;
      if (a > 1) p2.push_back(a);
      if (a < p[i]-1) p2.push_back(p[i]-a);
      doit(i+1, p, p2, at-a, bt-p[i]+a, a, out);
      if (a < p[i]-1) p2.pop_back();
      if (a > 1) p2.pop_back();
    }
  }
}

int main() {
  int N, M;
  while (cin >> N >> M) {
    vector<int> A(M);
    for (int i = 0; i < M; i++) cin >> A[i];

    vector<vector<int>> part{{N}};
    for (int i = 0; i < M; i++) {
      vector<vector<int>> part2;
      for (auto const& p : part) {
        vector<int> np;
        doit(0, p, np, A[i], N-A[i], -1, part2);
      }

      part.swap(part2);
      for (auto& p : part) sort(p.begin(), p.end());
      sort(part.begin(), part.end());
      part.erase(unique(part.begin(), part.end()), part.end());
    }

    int ret = 0;
    for (auto const& p : part) {
      int cur = N;
      for (auto x : p) cur -= x;
      ret = max(ret, cur);
    }
    cout << ret << endl;
  }
}
